# ңפȤ by nomonomo
#
# $Id: Client.pm,v 1.1 2004/03/03 07:38:07 white Exp $
#
# ѥå̾ꤹ롣
package ROTool::Ragpos::Client;

# ³ƥ١⥸塼use & Ѿ
use strict;
use ROTool;
use ROTool::Client;
use vars qw(@ISA);
@ISA = qw( ROTool::Client ROTool );

# ץꥱСεҡߤǤɤ
my $APPRI_VER = "Ragpos 0.1";

# бMapѡ
my $__job_map_already_read__;
my %job_id2str;
my %job_str2id;

# 饤ȽѤΥ饹᥽åtypechecker
#   typecheckerimportROToolϿ졢
#   ROTool::recv()ƤФ뤳Ȥˤʤ롣
sub typechecker{
    # It's not a method, but method-like callback function.
    # It's called from ROTool::recv().
    my $self = shift;
    if($self->{"buf"} =~ /^L=/){
	bless $self;
	$self->new();
	return 1;
    }else{
	return 0;
    }
}

# Υ⥸塼importtypecheckerϿ롣
sub import{
    # don't delete above line.
    &ROTool::typechecker_regist(\&typechecker);
}

# 󥹥ȥ饯 new
# ROTool::recv()typecheckerȤäƥ饤Ƚ̤Ԥʤ줿塢
# Ŭ礷Ƥ˸ƤФüʥ󥹥ȥ饯
sub new{
    my $self = shift;
    # It's morph-processor method, not a constractor.
    $self = $self->SUPER::new(@_);
    $self->{"param"}->{"APPRI_VER"} = $APPRI_VER;

    # <->idѴơ֥ɤ߹ߡ
    if(not $__job_map_already_read__
       && defined $self->{opt}->{ragpos_job}){
	open(TABLE,$self->{opt}->{ragpos_job});
	while(<TABLE>){
	    my($id,$str) = split('=',$_);
	    if($id =~ /^\d+$/){
		$job_id2str{$id}  = $str;
		$job_str2id{$str} = $id;
	    }else{
		$job_str2id{$id} = $str;
	    }
	}
	$__job_map_already_read__ = 1;
    }
    return $self;
}

sub is_client{
    return 1;
}

sub is_server{
    return 0;
}

# åν
#   åβϡUAϿͤμ谷ʤɤԤʤ
#   $self->SUPER::recv() ¹Ԥȡ$self->{buf}˼å롣
#   θβǽѤʬŬڤ˺뤳ȡ
#   ͤϡ̤ʾ$self->SUPER::recv()̤ͤ뤳ȡ
sub recv{
    my($self) = shift;

    my($ret) = $self->SUPER::recv();
    &ROTool::printlog(4," [oid = $self->{oid}] parse message\n");

    while($self->{"buf"} =~ s/L=(\d*)\001?(.*?)\002//){
	my $length = $1;
	my $msg = $2;
	@_ = split(/\001/,$msg);
	
# P=?,R=0?,I=id,M=msseage
	
	my $r = $_[1];
	
	splice(@_,0,2);
	
	my $message = $_[0];
	if($message ne $self->{"param"}->{"message"}){
	    $self->timestamp();
	}
	
	my @data = @_;

	$r =~ s/^R=(\d).*?/$1/;

	if ($r eq "0")
	{
	    @{$self->{"param"}}{"id","message"} = @data;
	    $self->{"param"}->{"id"} =~ s/^I=(.*)/$1/;
	    $self->{"param"}->{"message"} =~ s/^M=(.*)/$1/;
	} else {
	    @{$self->{"param"}}{"id","message","zeny","exp","expmax","job","jobmax","weight","weightmax","baselv","joblv","hp","hpmax","sp","spmax","name","areaname","a1","gameservername","classno"} = @data;
	    $self->{"param"}->{"id"} =~ s/^I=(.*)/$1/;
	    $self->{"param"}->{"message"} =~ s/^M=(.*)/$1/;
	    $self->{"class"} =
		$job_id2str{$self->{"classno"}} || $self->{"classno"};
	}
	
    }
    if(&ROTool::UA_regist($self->{"param"}->{"id"},$self) == 0){
	return 0;
    }
    return $ret;
}

# åν
sub send{
    my $self = shift;
    my $count = 0;
    my @msg;

#  å
#    &ROTool::UA_list()ȤäƳƥ饤ȥ֥Ȥ
#    ƥ饤ȤΥǡץȥŬ礷ǡ롣
    foreach my $client(&ROTool::UA_list()){
	# Fetch data from UA_list.
	# and make message send to peer client.
	next if($client->is_client() == 0);
	$count++;
	my %param = %{$client->{param}};
	$param{"server"}   ||= "----";
	$param{"hp"}       ||= 0;
	$param{"hpmax"}    ||= 0;
	$param{"sp"}       ||= 0;
	$param{"spmax"}    ||= 0;
	$param{"baselv"}   ||= 0;
	$param{"joblv"}    ||= 0;
	$param{"classno"}  ||= $job_str2id{$param{"class"}} || 0;
	$param{"zeny"}     ||= 0;
	$param{"exp"}      ||= 0;
	$param{"expmax"}   ||= 0;
	$param{"job"}      ||= 0;
	$param{"jobmax"}   ||= 0;
	$param{"weight"}   ||= 0;
	$param{"weightmax"}||= 0;
	$param{"hp"}       ||= 0;
	$param{"name"}     ||= "";
	$param{"areaname"} ||= "";
	$param{"a1"}       ||= "";
	$param{"gameservername"} ||= "";
	
	my @msg_s;
	push(@msg_s,"R=1","I=" . $param{"id"},"M=" . $param{"message"},
	     @param{"zeny","exp","expmax","job","jobmax","weight","weightmax",
		    "baselv","joblv","hp","hpmax","sp","spmax","name","areaname","a1",
		    "gameservername","classno"});
	my $temp = join("\001",@msg_s);
	$temp = $temp . "\001";
	push(@msg , $temp);
#		&ROTool::printlog(4,join("\001",@msg_s) . "\001\n");
	
    }
    my @msg_t;
    push(@msg_t,"P=200","V=2.21","C=$count",join("\002",@msg) . "\002");
    my $data_length = length("@msg_t");
    unshift(@msg_t,"L=$data_length");
    
#  å
#    Ǻäå롣
    # send message
    my $sock = $self->{"sock"};
    my $msg = join("\001",@msg_t);
    $sock->syswrite($msg,length($msg));
    &ROTool::printlog(4,"msg=[$msg]\n");
}


1;
